
from binarycpython.utils.ensemble import (
    binaryc_json_serializer,
    handle_ensemble_string_to_json,
)


# class test_return_binary_c_version_info(unittest.TestCase):
#     """
#     Unittests for return_binary_c_version_info
#     """

#     def test_not_parsed(self):
#         with Capturing() as output:
#             self._test_not_parsed()

#     def _test_not_parsed(self):
#         """
#         Test for the raw version_info output
#         """

#         version_info = return_binary_c_version_info(parsed=False)

#         self.assertTrue(isinstance(version_info, str))
#         self.assertIn("Build", version_info)
#         self.assertIn("REIMERS_ETA_DEFAULT", version_info)
#         self.assertIn("SIGMA_THOMPSON", version_info)

#     def test_parsed(self):
#         with Capturing() as output:
#             self._test_parsed()

#     def _test_parsed(self):
#         """
#         Test for the parssed version_info
#         """

#         # also tests the parse_version_info indirectly
#         version_info_parsed = return_binary_c_version_info(parsed=True)

#         self.assertTrue(isinstance(version_info_parsed, dict))
#         self.assertIn("isotopes", version_info_parsed.keys())
#         self.assertIn("argpairs", version_info_parsed.keys())
#         self.assertIn("ensembles", version_info_parsed.keys())
#         self.assertIn("macros", version_info_parsed.keys())
#         self.assertIn("elements", version_info_parsed.keys())
#         self.assertIn("dt_limits", version_info_parsed.keys())
#         self.assertIn("nucleosynthesis_sources", version_info_parsed.keys())
#         self.assertIn("miscellaneous", version_info_parsed.keys())



# class test_parse_binary_c_version_info(unittest.TestCase):
#     """
#     Unittests for function parse_binary_c_version_info
#     """

#     def test_1(self):
#         with Capturing() as output:
#             self._test_1()

#     def _test_1(self):
#         """
#         Test for the parsed versio info, more detailed
#         """

#         info = return_binary_c_version_info(parsed=False)
#         parsed_info = parse_binary_c_version_info(info)

#         self.assertIn("isotopes", parsed_info.keys())
#         self.assertIn("argpairs", parsed_info.keys())
#         self.assertIn("ensembles", parsed_info.keys())
#         self.assertIn("macros", parsed_info.keys())
#         self.assertIn("elements", parsed_info.keys())
#         self.assertIn("dt_limits", parsed_info.keys())
#         self.assertIn("nucleosynthesis_sources", parsed_info.keys())
#         self.assertIn("miscellaneous", parsed_info.keys())

#         self.assertIsNotNone(parsed_info["argpairs"])
#         self.assertIsNotNone(parsed_info["ensembles"])
#         self.assertIsNotNone(parsed_info["macros"])
#         self.assertIsNotNone(parsed_info["dt_limits"])
#         self.assertIsNotNone(parsed_info["miscellaneous"])

#         if parsed_info["macros"]["NUCSYN"] == "on":
#             self.assertIsNotNone(parsed_info["isotopes"])

#             if parsed_info["macros"]["NUCSYN_ID_SOURCES"] == "on":
#                 self.assertIsNotNone(parsed_info["nucleosynthesis_sources"])



# class test_inspect_dict(unittest.TestCase):
#     """
#     Unittests for function inspect_dict
#     """

#     def test_compare_dict(self):
#         with Capturing() as output:
#             self._test_compare_dict()

#     def _test_compare_dict(self):
#         """
#         Test checking if inspect_dict returns the correct structure by comparing it to known value
#         """

#         input_dict = {
#             "int": 1,
#             "float": 1.2,
#             "list": [1, 2, 3],
#             "function": os.path.isfile,
#             "dict": {"int": 1, "float": 1.2},
#         }
#         output_dict = inspect_dict(input_dict)
#         compare_dict = {
#             "int": int,
#             "float": float,
#             "list": list,
#             "function": os.path.isfile.__class__,
#             "dict": {"int": int, "float": float},
#         }
#         self.assertTrue(compare_dict == output_dict)

#     def test_compare_dict_with_print(self):
#         with Capturing() as output:
#             self._test_compare_dict_with_print()

#     def _test_compare_dict_with_print(self):
#         """
#         Test checking output is printed
#         """

#         input_dict = {
#             "int": 1,
#             "float": 1.2,
#             "list": [1, 2, 3],
#             "function": os.path.isfile,
#             "dict": {"int": 1, "float": 1.2},
#         }
#         output_dict = inspect_dict(input_dict, print_structure=True)





# class test_binaryc_json_serializer(unittest.TestCase):
#     """
#     Unittests for function binaryc_json_serializer
#     """

#     def test_not_function(self):
#         with Capturing() as output:
#             self._test_not_function()

#     def _test_not_function(self):
#         """
#         Test passing an object that doesnt get turned in to a string
#         """

#         stringo = "hello"
#         output = binaryc_json_serializer(stringo)
#         self.assertTrue(stringo == output)

#     def test_function(self):
#         with Capturing() as output:
#             self._test_function()

#     def _test_function(self):
#         """
#         Test passing an object that gets turned in to a string: a function
#         """

#         string_of_function = str(os.path.isfile)
#         output = binaryc_json_serializer(os.path.isfile)
#         self.assertTrue(string_of_function == output)


# class test_handle_ensemble_string_to_json(unittest.TestCase):
#     """
#     Unittests for function handle_ensemble_string_to_json
#     """

#     def test_1(self):
#         with Capturing() as _:
#             self._test_1()

#     def _test_1(self):
#         """
#         Test passing string representation of a dictionary.
#         """

#         _ = str(os.path.isfile)
#         input_string = '{"ding": 10, "list_example": [1,2,3]}'
#         output_dict = handle_ensemble_string_to_json(input_string)

#         self.assertTrue(isinstance(output_dict, dict))
#         self.assertTrue(output_dict["ding"] == 10)
#         self.assertTrue(output_dict["list_example"] == [1, 2, 3])


# class test_AutoVivicationDict(unittest.TestCase):
#     """
#     Unittests for AutoVivicationDict
#     """

#     def test_add(self):
#         """
#         Tests to see if the adding is done correctly
#         """

#         result_dict = AutoVivificationDict()

#         result_dict["a"]["b"]["c"] += 10

#         self.assertEqual(result_dict["a"]["b"]["c"], 10)
#         result_dict["a"]["b"]["c"] += 10
#         self.assertEqual(result_dict["a"]["b"]["c"], 20)


# class test_setopts(unittest.TestCase):
#     """
#     Unit test class for setopts
#     """

#     def test_setopts(self):
#         with Capturing() as output:
#             self._test_setopts()

#     def _test_setopts(self):
#         """
#         Unittest for function set_opts
#         """

#         default_dict = {"m1": 2, "m2": 3}
#         output_dict_1 = set_opts(default_dict, {})
#         self.assertTrue(output_dict_1 == default_dict)

#         new_opts = {"m1": 10}
#         output_dict_2 = set_opts(default_dict, new_opts)
#         updated_dict = default_dict.copy()
#         updated_dict["m1"] = 10

#         self.assertTrue(output_dict_2 == updated_dict)